/* compile.h
	P.Chongstitvatana
	19 Aug 97

	3 Apr 2001  start project RZ
	21 Oct 2002  project A1
	6 Jan 2004   project som-c
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "icname.h"
#include "token.h"
/*
#define DEBUG

#define VERBOSE
*/

#define	TABLESIZE		500
#define LOCALSIZE       100
#define NAMELEN			32
#define CASESIZE		100
#define MAXYSTK			1000

/* memory map
  M[ system | --> DS   | --> CS | cell ]
            ^          ^        ^      ^
           MAXSYS    MAXDS    MAXCS   MAXMEM

  SS[MAXSS]
*/
#define MAXMEM			500000
#define MAXCS			200000
#define MAXDS           100000
#define MAXSYS			1000	// interface C-som
#define MAXSS			5000
#define MAXSTR			256		// max tokstring length

#define	tkIDEN		    14
#define	tkNUMBER        15
#define	tkSTRING        16
#define	tkEOF           17
#define	tkERROR         18

#define tyNEW			10
#define tyFUNC			6
#define tyLOCAL			7
#define tyGVAR			8
#define tyENUM			9
#define tyMAC			11		// macro
#define tyFULL			12		// full macro

#define NL_CHAR			10
#define EOF_CHAR		255

#define MARK			1	// marker in ystack stmt.c
#define BMARK			2	// break marker
#define NIL				0

// atom
#define SP				0   // special
#define OPER			1   // operators
#define NUM				2   // number
#define GNAME			3	// global name
#define LNAME			4	// local name
#define	CNAME			5	// class name
#define STRING			6   // string

#define  eqs(a,b)  (strcmp(a,b) == 0)

typedef unsigned char uchar;

typedef struct {
  char name[NAMELEN];
  int  type;
  int  ref;			// point to code
  int  arg;			// arity
  int  lv;			// total no. of var
  int  pref;		// point to parse tree
} sym_entry;

extern  char tokstring[];	/* current token string */
extern  int tok;			/* current token */
extern  int line;			/* current position in source */
extern  uchar CH;			/* current char */
extern  int *CS;			/* code segment */
extern  int M[];			/* data, code, cell */
extern  int DS;				/* free data pointer */
extern  int CP;				/* current code pointer */
extern  int currentf;		// current function index

/* function prototypes */

void getC(void);				/* lex.c */
int isLetterOrDigit(uchar c);
void lex(void);
void readinfile(char *fname);
void startlex(void);
void savelex(void);
void restorelex(void);
void prToken(int tok);
void prtok(int tok);
void reader(void);
void initCharType(void);
void freebuf(void);

void seterror( char *mess );	/* a1.c */
void warning( char *mess);
void loadfile( char *fn );

int enterLocal(char *name);		/* symtab.c */
int enterGlobal(char *name, int type, int ref, int arg);
int getRef(int index);
void setRef(int index, int ref);
void dumpSymTab(FILE *fo);
char *findName(int type, int ref);
char *getName(int nm);
int search(char *name);
int getArg(int idx);
void setArg(int idx, int arg);
int getLv(int idx);
void setLv(int idx, int lv);
int getType(int idx);
int getIdx(int ref);
void setType(int index, int type);
void setPref(int idx, int p);
int getPref(int idx);

void outa( int code, int arg);	/* icode.c */
void outs( int code);
void patch( int ads, int v );
void showCode(FILE *fo);
void decode(int ip, int *code, int *data);
void decode2(int op, int *code, int *data);
void putcode(int ip, int code, int data);
void clean(int idx);
void outCode(FILE *fo);
//void readCode(FILE *fi);
void patchbreak(void);
void patchCalli(int a, int b);
void cleanm(int fn);

//int ex();						/* parse.c */
int ex0(void);
int mod(void);
int top(void);
int terms(void);

void expect( int tktype, char *mess );	/* stmt.c */
void commit( int status );
int ypop(void);
void ypush(int item);
int ytos(void);
void setfname(int ty);
void setarity(void);
void dofun(int op);
void doblock(void);
void doif(void);
void dowhile(void);
void dofor(void);
//void doset(void);
void dosys(void);
void dobop(int bop);
void donum(int value);
//void dovar(int idx);
void dovec(void);
//void docall(int idx);
void douop(int uop);
void docase(void);
void dolocal(void);
void doenum(void);
void doiden(int idx);
void dolabel(void);
void prstr(int i);
void dostring(char *s);
void strpack(int s1, char *s2);
void strunpack(char *s1, int s2);
int exas(void);

void eval(int a);				/* interp.c */
int xalloc(int a);

void initcell(void);			/* list.c */
int newatom(int type, int value);
int isatom(int a);
//int islist(int a);
int car(int l);
int cdr(int l);
int cons(int a, int l);
int list(int a);
void prlist(int l);
int append(int l, int x);
//int countcell(void);

void genex(int e);					/* gencode.c */
void genimm(int e);
void runimm(int e);
void genlist(int e);

void domacro(int idx, int el);	// macro.c
